<%@ Language=VBScript %>
<%
'ADOBE SYSTEMS INCORPORATED
'Copyright [1999] - [2001] Adobe Systems Incorporated
'All Rights Reserved

'NOTICE:  Adobe permits you to use, modify, and distribute 
'this file in accordance with the terms of the Adobe license 
'agreement accompanying it.  If you have received this file 
'from a source other than Adobe, then your use, modification, 
'or distribution of it requires the prior written permission of Adobe.


Rem This script receives the form data and the incremental changes
'   of the test file 'TestAppendSaves.pdf'; pings the document and the 
'   changes back to the browser for the user to see, and save a copy
'   of the document and the incremental changes to the server's hard
'   drive.
' The steps, this script....
'   (1) Extracts the incremental change file using FDFExtractAppendSaves
'       of the FDF Toolkit (Version 5.0 required) and saves it under the
'       path cTempFileSaveAppends, which can be changed.
'   (2) Does a 'Signer=FDFGetValue("sigInfoText")'. The file TestAppendSaves.pdf
'       has a hidden text file that contains the name of the signer
'       and the time the document was signed. The script uses this
'       to form the base name of the file that will be saved.
'   (3) The script 'pings' the document and incremental changes back to
'       the browser: First send a copy of the TestAppendSaves.pdf document
'       resident on the server's hard drive, then just behind that, send
'       the append save portion.  See the eBook 'PDFRef.pdf', section
'       3.4.5, on Incremental Updates (pp. 62-63).  Basically, these updates 
'       are appended to the end of the original PDF file. So if
'       we send the original followed by the append save portion in a 
'       binary sort of way, we have sent the complete revised document to
'       the browser!
'   (4) Finally, this script saves the revised document to the server's hard
'       drive using the path cCombinedFilePath, which can be redefined and
'       a base name of 'Signer', see (2) above.

Rem Important. VBScript does not have any built-in methods for manipulating
'   binary data files, so a custom ActiveX component was written. This component
'   is based on the Microsoft paper "HOWTO: Read and Display Binary Data 
'   in ASP", see http://support.microsoft.com/support/kb/articles/q193/9/98.asp
'   There was one error in the supplied code. A binReadWrite.dll was written
'   that has two class modules BinRead and BinWrite . Usage:
'   (1) Set binObj = Server.CreateObject("binReadWrite.BinRead")
'       vntStream = binObj.readBinFile(cPdfFileName)
'       readBinFile opens and does a binary read of the file from the server's 
'       hard drive as  determined by its argument 'cPdfFileName', in this example, 
'       and returns a byte stream of the file. In this script, the above
'       two lines are followed by
'       Response.BinaryWrite(vntStream)
'       which sends the stream back to  the browser.
'   (2) Set binObj = Server.CreateObject("binReadWrite.BinWrite")
'       binObj.writeBinFile cPdfFileName, cTempFileSaveAppends, cCombinedFile
'       writeBinFile takes three arguments. The first two are paths to
'       (binary) files. writeBinFile will take the two file, as determined
'       by the first two argument and concatenate them,
'       symbolically, cPdfFileName + cTempFileSaveAppends, and save
'       the resultant file under the page cCombinedFile. Note: if the
'       second argument is the empty string, then writeBinFile will take
'       the first argument and save it as the third argument.
' The source code and dll should accompany this script and demo.

Response.buffer = True
' Response.ContentType = "text/html"
Response.ContentType = "application/pdf"

Dim cTempFileSaveAppends 
Dim cPdfFileName
Dim cCombinedFile, cCombinedFilePath
Dim vntStream, binObj, fso
Dim Signer

Rem These paths can be changed to reflect the server environment
cTempFileSaveAppends = "c:\inetpub\wwwroot\PDFs\tmp\AppendUpdate.tmp"
cPdfFileName = "c:\inetpub\wwwroot\PDFs\AppendUpdate.pdf"
cCombinedFilePath = "c:\inetpub\wwwroot\PDFs\tmp\"

Rem Create an FDF object
Set FdfAcx = Server.CreateObject("FdfApp.FdfApp") 

Rem Parse Incoming Data
Set FDFin = FdfAcx.FDFOpenFromBuf (Request.BinaryRead(Request.TotalBytes))

Rem Save append saves to the file cTempFileSaveAppends, this includes
'   signature, comments form fields modified, document summary summary 
'   info---*any* changes. Neat.
FDFin.FDFExtractAppendSaves cTempFileSaveAppends

Rem Construct name of saved file, this file will be a copy of the
'   file the user signed. The name of this file will is based on
'   the signer's name and the current date/time.
'   File name format: namemmddyyHHMM
'   All non-word chars are removed from the signer's name before
'   begin sent to this ASP. This informationi is contained in a
'   hidden text field within the document named "sigInfoText".
Signer = FDFin.FDFGetValue("sigInfoText")
cCombinedFile = cCombinedFilePath & Signer & ".pdf"

Rem Create an object to be used for reading and displaying binary data
'   See the Microsolf article, entitled
'   HOWTO: Read and Display Binary Data in ASP
'   http://support.microsoft.com/support/kb/articles/q193/9/98.asp
Set binObj = Server.CreateObject("binReadWrite.BinRead")

' Send a copy of the document back to the browser
vntStream = binObj.readBinFile(cPdfFileName)
Response.BinaryWrite(vntStream)

' Send the incremental save portion back to the browser
vntStream = binObj.readBinFile(cTempFileSaveAppends)  
Response.BinaryWrite(vntStream)

' Now save a copy for the disk
Set binObj = Server.CreateObject("binReadWrite.BinWrite")
binObj.writeBinFile cPdfFileName, cTempFileSaveAppends, cCombinedFile

' Now delete cTempFileSaveAppends
Set fso = Server.CreateObject("Scripting.FileSystemObject")
fso.DeleteFile cTempFileSaveAppends

Set fso = Nothing
Set binObj = Nothing

Response.End
FDFin.FDFClose
%>
