#ADOBE SYSTEMS INCORPORATED
#Copyright [1999] - [2001] Adobe Systems Incorporated
#All Rights Reserved

#NOTICE:  Adobe permits you to use, modify, and distribute 
#this file in accordance with the terms of the Adobe license 
#agreement accompanying it.  If you have received this file 
#from a source other than Adobe, then your use, modification, 
#or distribution of it requires the prior written permission of Adobe.

# Please see employee_query.pl for more info on this sample

use Acrobat::FDF;

@schema = ('ssn', 'name.first', 'name.initial', 'name.last', 'home.address.line1',
		   'home.address.line2', 'home.address.line3', 'home.address.city', 'home.address.state',
		   'home.address.zip', 'home.telephone.voice.areacode', 'home.telephone.voice.number',
		   'birthdate.month', 'birthdate.day', 'birthdate.year', 'gender');

$outFdf = new Acrobat::FDF;

binmode STDIN;
read STDIN, $buf, $ENV{'CONTENT_LENGTH'};
$inFdf = Acrobat::FDF::newFromBuf($buf);

$ssn = $inFdf->GetValue("ssn");
$newRecord = '';
foreach $key (@schema) { # Construct the comma-separated record from the data in the received FDF
	$newRecord .= $inFdf->GetValue($key);
	$newRecord .= ',';
}
chop($newRecord);

open EMP_DB, 'c:\InetPub\scripts\employee_db.txt';
open EMP_DB_OUT, '>c:\InetPub\scripts\employee_db2.txt';

$bPrintedNew = 0;
while ($record = <EMP_DB>) { # Read each record from the "database"
	if ($record =~ /^$ssn/) { # And see if it is the record for the employee who just submitted his update.
		print EMP_DB_OUT "$newRecord\n"; # Yes it is. Write the new, updated record instead of the old one.
		$bPrintedNew = 1;
	}
	else {
		print EMP_DB_OUT $record; # This is the record of a different employee. Write it out intact.
	}
}

if (!$bPrintedNew) {
	# If we didn't find the record, it means it's an insert, not an update. Write the new record out.
	print EMP_DB_OUT "$newRecord\n";
}

close EMP_DB;
close EMP_DB_OUT;

# The approach shown here for updating our pseudo-database is for illustration purposes only,
# and is not robust for a real situation. All we are trying to show is how to use the FdfTk, not
# database technology!
rename 'c:\InetPub\scripts\employee_db2.txt', 'c:\InetPub\scripts\employee_db.txt';

$inFdf->GetAP('photo', FDFNormalAP,
			  'C:\InetPub\wwwroot\pdfs\photos\\' . $inFdf->GetValue('name.last') . '.pdf');

$outFdf->SetValue('status', 'Record updated. Thank you!', 0);

print "Content-type: application/vnd.fdf\n\n";

binmode STDOUT;
print $outFdf->SaveToBuf();
