<%@ LANGUAGE = VBScript%>
<!--#include virtual="/ADOVBS.INC"-->
<%
Response.ContentType = "application/vnd.fdf"

Rem Create an FDF objecj 
Set FdfAcx = Server.CreateObject("FdfApp.FdfApp") 
Set FDFout = FdfAcx.FDFCreate

Rem Parse Incoming Data
Set FDFin = FdfAcx.FDFOpenFromBuf (Request.BinaryRead(Request.TotalBytes))

Rem Declare some variables
Dim dbName, tableName, sqlType, primaryKey, id
Dim DataConn, RecSet, currentField, dbCurrentField

Dim DebugTxt, DebugFDF
Rem Some debugging tools
DebugFDF = False
DebugTxt = False    

If DebugTxt Then
    Response.ContentType = "text/html" 
End If    


Rem Get the hard-wired info for this pdf. No error checking is done
'   on this.  It is assumed the PDF document has these four fields
'   and they are populated with the appropriate values.

Rem Get the database name
dbName = FDFin.FDFGetValue("dbName")

Rem An alternate approach is to use dbName as an application variable
'   that way the PDF does not contain the DB name.  
'   Uncomment the next line, as desired.
'dbName = Application(dbName)

Rem Get the table name
tableName = FDFin.FDFGetValue("tableName")

Rem An alternate approach is to use tableName as an application variable
'   that way the PDF does not contain the table name.
'   Uncomment the next line, as desired.
'tableName = Application(tableName)

Rem Get "sqlType"
sqlType = FDFin.FDFGetValue("sqlType")

Rem Get primary key
primaryKey = FDFin.FDFGetValue("primaryKey")

Rem Get value of primary key
'   If sqlType=3, we are adding a new record and we assume the
'   primaryKey is an auto-count variable in the data, and it
'   will supply an id number. In this case ProcessInsert will
'   return the new id number for the added record.
If sqlType = 3 Then
    id = 0           ' temp id, database will supply
Else
    id = FDFin.FDFGetValue(primaryKey)
End If

On error Resume Next
Rem Query the database
Set DataConn = Server.CreateObject("ADODB.Connection")
DataConn.Open dbName
If Err.Number <> 0 Then
    FDFout.FDFSetStatus "Could not connect to database, sorry."
    ' Send back to the browser
    Response.BinaryWrite FDFout.FDFSaveToBuf
    FDFin.FDFClose
    FDFout.FDFClose
    Set DataConn = Nothing
    Response.End
End If        

Select Case sqlType
    Case 0
        ProcessQuery tableName, primaryKey, id
    Case 1
        ProcessUpdate tableName, primaryKey, id
    Case 2
        ProcessInsert tableName, primaryKey, id
    Case 3
        ProcessInsert tableName, primaryKey, id
End Select

FDFin.FDFClose
FDFout.FDFClose
RecSet.Close
Set RecSet = Nothing
DataConn.Close
Set DataConn = Nothing
Response.End
%>

<%
Sub ProcessQuery (tableName, primaryKey, id)

    Dim SQL, dbContinue, StatusErcMsg
    StatusErcMsg = "Problems Report: "
    
    SQL = "Select * From " & tableName _
          & " Where " &primaryKey& " = " &id&";"
    
    On error Resume Next
    
    Set RecSet = DataConn.Execute(SQL)
    If Err.Number <> 0 Then
        If DebugFDF Then
            FDFout.FDFSetStatus _
                "Could not find the specified Table, '"_
                &tableName&"', in the database, '"&dbName&"'."_
                &" Note: " &primaryKey & " = " & id
        Else
            If DebugTxt Then
                Response.Write "Error: " & Err.Number &"<br>"
                Response.Write "Description: " & Err.Description&"<br>"
                Response.Write "Field Name: " & currentField&"<br>"
            End If
            FDFout.FDFSetStatus _
                "Could not find the specified Table in the Database, sorry."
        End If
        ' Send back to the browser
        Response.BinaryWrite FDFout.FDFSaveToBuf
        Exit Sub        
    End If
    If RecSet.BOF And RecSet.EOF Then
        FDFout.FDFSetStatus "Record not Found in Database."
        ' Send back to the browser
        Response.BinaryWrite FDFout.FDFSaveToBuf
        Exit Sub
    End If

    dbContinue = True
    currentField = FDFin.FDFNextFieldName("")        
    Do While dbContinue=True
        Select Case currentField
            Case "dbName"
            Case "tableName"
            Case "sqlType"
            Case "primaryKey"
            Case Else
                ' if pdfField name has an '.', replace it with "_"
                dbCurrentField = Replace(currentField, ".", "_")
                Err.Clear
                FDFout.FDFSetValue currentField, RecSet(dbCurrentField).Value, False
                    If Err.Number <> 0 Then
                        If DebugFDF Then
                            StatusErcMsg = StatusErcMsg & " Could "_
                                &" not retrieve the DB field, '"_
                                &dbCurrentField&"', using "_
                                &"the value from the form field, '"_
                                &currentField&"'."
                        End If                
                        ' ignore this error
                        Err.Clear
                    End If
        End Select
        on error resume next
        currentField = FDFin.FDFNextFieldName(currentField)        
        If currentField = "" Or Err.Number <> 0 Then 
            dbContinue=False 
        End If
    Loop
    ' Send back to the browser
    If DebugFDF Then
        FDFout.FDFSetStatus StatusErcMsg
    End If
    Response.BinaryWrite FDFout.FDFSaveToBuf
End Sub    

Sub ProcessUpdate (tableName, primaryKey, id)

    Dim dbContinue, StatusSuccess, StatusErcMsg, ErcCancel
    
    StatusSuccess = "Record Updated Successfully!"
    StatusErcMsg = " Problems Report: "
    ErcCancel = "Could not update data, Sorry."

    on error resume next        

    Rem Now we want to take the data from the FDF and update 
    '   this to the database.
    Set RecSet = Server.CreateObject("ADODB.Recordset")
    RecSet.CursorType = adOpenKeyset
    RecSet.LockType = adLockOptimistic
    RecSet.ActiveConnection = DataConn
    RecSet.Source = "Select * From " & tableName _
        & " Where " &primaryKey& " = " &id&";"
    DataConn.BeginTrans
    RecSet.Open
    If RecSet.BOF And RecSet.EOF Then
        FDFout.FDFSetStatus "Record not Found in Database."
        Response.BinaryWrite FDFout.FDFSaveToBuf
        Exit Sub
    End If
        
    dbContinue = True
    Dim Counter
    currentField = FDFin.FDFNextFieldName("")
    Do While dbContinue=True
        Select Case currentField
            Case "dbName"
            Case "tableName"
            Case "sqlType"
            Case "primaryKey"
            Case primaryKey       ' do not write to primaryKey field
            Case Else
                ' if pdfField name has an '.', replace it with "_"
                dbCurrentField = Replace(currentField, ".", "_")
                Err.Clear
                currentValue = FDFin.FDFGetValue(currentField)
                If Err.Number <> 0 Then
                    If DebugTxt Then
                        Response.Write "Error: " & Err.Number &"<br>"
                        Response.Write "Description: " & Err.Description&"<br>"
                        Response.Write "Field Name: " & currentField&"<br>"
                        Err.Clear
                    End If
                Else
                    RecSet(dbCurrentField) = currentValue
                    If Err.Number <> 0 Then
                        ' Probably the dbCurrentField does not exist is DB
                        If DebugFDF Then
                            StatusErcMsg = StatusErcMsg & " Could "_
                            &" not Update the DB field, '"_
                            &dbCurrentField&"', using "_
                            &"the value from the form field, '"_
                            &currentField&"'."
                        End If
                        ' Ignore the error
                        Err.Clear
                    End If
                End If
        End Select
        currentField = FDFin.FDFNextFieldName(currentField)        
        If currentField = "" Or Err.Number <> 0 Then 
            dbContinue=False 
            Err.Clear
        End If
    Loop
    If  DataConn.Errors.Count > 0 Then
        If DebugTxt Then
            For each Error in DataConn.Errors
                Response.Write "Error Number: " & Error.Number &"<br>"
                Response.Write "Error Description: " & Error.Description &"<br>"
            Next
        End If
        DataConn.CancelUpdate
        DataConn.RollbackTrans
        FDFout.FDFSetStatus ErcCancel
    Else
        RecSet.Update
        DataConn.CommitTrans
        If DebugFDF Then
            FDFout.FDFSetStatus StatusSuccess & StatusErcMsg
        Else
            FDFout.FDFSetStatus StatusSuccess
        End If
    End If
    ' Send back to the browser
    Response.BinaryWrite FDFout.FDFSaveToBuf
End Sub

Sub ProcessInsert (tableName, primaryKey, id)

    Dim dbContinue, SQL, StatusSuccess, StatusErcMsg, ErcCancel
    
    StatusSuccess = "Success, new record added to the Database."
    StatusErcMsg = "  Problems Report: "
    ErcCancel = "Could not add in new data, Sorry."
    
    on error resume next
    If sqlType = 2 Then
        SQL = "Select * From " & tableName & " Where " &primaryKey& " = " &id&";"
        Set RecSet = DataConn.Execute(SQL)
        If Not (RecSet.BOF And RecSet.EOF) Then
            FDFout.FDFSetStatus "Record already exists in this Database. Try a Query or Update."
            Response.BinaryWrite FDFout.FDFSaveToBuf
            Exit Sub
        End If
    End If

    Set RecSet = Server.CreateObject("ADODB.Recordset")
    RecSet.CursorType = adOpenKeyset  
    RecSet.LockType = adLockOptimistic
    RecSet.ActiveConnection = DataConn
    RecSet.Source=tableName
    DataConn.BeginTrans
    RecSet.Open
    RecSet.AddNew
    dbContinue = True
    currentField = FDFin.FDFNextFieldName("")
    If currentField = "" Then dbContinue = False End If
    Do While dbContinue=True
        Select Case currentField
            Case "dbName"
            Case "tableName"
            Case "sqlType"
            Case "primaryKey"
            Case Else
                ' if pdfField name has an '.', replace it with "_"
                dbCurrentField = Replace(currentField, ".", "_")
                Err.Clear
                currentValue = FDFin.FDFGetValue(currentField)
                If Err.Number <> 0 Then
                    If DebugTxt Then
                        Response.Write "Err: " & Err.Number &"<br>"
                        Response.Write "Description: " & Err.Description&"<br>"
                        Response.Write "Field Name: " & currentField&"<br>"
                    End If
                    Err.Clear
                Else
                    RecSet(dbCurrentField).Value = currentValue
                    If Err.Number <> 0 Then
                        If DebugFDF Then
                            StatusErcMsg = StatusErcMsg & "  The Field, '"_
                             &dbCurrentField&"', does not exist in the DB "_
                             &"for FDF Data in the form field '"&currentField&"'."
                        End If
                    End If
                    ' Ignore error and carry on
                    Err.clear
                End If                
        End Select
        currentField = FDFin.FDFNextFieldName(currentField)        
        If currentField = "" Or Err.Number <> 0 Then 
            If DebugTxt Then
               Response.Write "Err: " & Err.Number &"<br>"
               Response.Write "Description: " & Err.Description&"<br>"
               Response.Write "Field Name: " & currentField&"<br>"
            End If
            dbContinue=False 
            Err.Clear
        End If
    Loop
    ' Now we've entered the new row in the database
    ' If the sqlType = 3, then we'll return the value of the primaryKey field
    ' If this field, in the DB table, is auto-numbered, then it acts as a
    ' customer ID.
    If sqlType = 3 Then
        Err.Clear
        RecSet.ReSync
        FDFout.FDFSetValue primaryKey, RecSet(primaryKey).Value, False
            If Err.Number <> 0 Then
                If DebugFDF Then
                    StatusErcMsg = StatusErcMsg & " Could "_
                        &" not retrieve the DB field, '"_
                        &dbCurrentField&"', using "_
                        &"the value from the form field, '"_
                        &currentField&"'."
                End If                
                ' ignore this error
                Err.Clear
            End If
    End If
    If DataConn.Errors.Count > 0 Then
        If DebugTxt Then
            For each Error in DataConn.Errors
                Response.Write "Error Number: " & Error.Number &"<br>"
                Response.Write "Error Description: " & Error.Description &"<br>"
            Next
        End If
        RecSet.CancelUpdate
        DataConn.RollbackTrans
        FDFout.FDFSetStatus ErcCancel
    Else
        RecSet.Update
        DataConn.CommitTrans
        If DebugFDF Then
            FDFout.FDFSetStatus StatusSuccess & StatusErcMsg
        Else
            FDFout.FDFSetStatus StatusSuccess
        End If
    End If
    ' Send back to the browser
    Response.BinaryWrite FDFout.FDFSaveToBuf
End Sub
%>
